package org.firstinspires.ftc.teamcode.cometbots;

import com.qualcomm.robotcore.hardware.DcMotor;
import com.qualcomm.robotcore.hardware.DcMotorSimple;

public class MovementLibrary {

    public static void setDirectionForward(DcMotor[] motors) {
        setLeftSideForward(motors);
        setRightSideForward(motors);
    }

    public static void setLeftSideForward(DcMotor[] motors) {
        motors[2].setDirection(DcMotor.Direction.FORWARD);
        motors[3].setDirection(DcMotor.Direction.REVERSE);
    }

    public static void setRightSideForward(DcMotor[] motors) {
        motors[0].setDirection(DcMotor.Direction.REVERSE);
        motors[1].setDirection(DcMotor.Direction.FORWARD);
    }

    public static void setLeftSideBackward(DcMotor[] motors) {
        motors[2].setDirection(DcMotor.Direction.REVERSE);
        motors[3].setDirection(DcMotor.Direction.FORWARD);
    }

    public static void setRightSideBackward(DcMotor[] motors) {
        motors[0].setDirection(DcMotor.Direction.FORWARD);
        motors[1].setDirection(DcMotor.Direction.REVERSE);
    }


    public static void setDirectionBackward(DcMotor[] motors) {
        setLeftSideBackward(motors);
        setRightSideBackward(motors);
    }

    public static void setSpeed(DcMotor[] motors, double speedValue) {
        for (DcMotor motor : motors) {
            motor.setPower(speedValue);
        }
    }

    public static void setDirectionLeft(DcMotor[] motors) {
        motors[0].setDirection(DcMotor.Direction.REVERSE);
        motors[1].setDirection(DcMotor.Direction.REVERSE);
        motors[2].setDirection(DcMotor.Direction.FORWARD);
        motors[3].setDirection(DcMotor.Direction.FORWARD);
    }

    public static void setDirectionRight(DcMotor[] motors) {
        motors[0].setDirection(DcMotor.Direction.FORWARD);
        motors[1].setDirection(DcMotor.Direction.FORWARD);
        motors[2].setDirection(DcMotor.Direction.REVERSE);
        motors[3].setDirection(DcMotor.Direction.REVERSE);
    }
}
